
//          Copyright John McFarlane 2016.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file ../LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

/// \file
/// \brief essential definitions related to the `cnl::elastic_integer` type

#if !defined(CNL_ELASTIC_INTEGER_H)
#define CNL_ELASTIC_INTEGER_H

#include "_impl/elastic_integer/declaration.h"
#include "_impl/elastic_integer/definition.h"
#include "_impl/elastic_integer/digits.h"
#include "_impl/elastic_integer/from_rep.h"
#include "_impl/elastic_integer/from_value.h"
#include "_impl/elastic_integer/generic.h"
#include "_impl/elastic_integer/is_number.h"
#include "_impl/elastic_integer/make_elastic_integer.h"
#include "_impl/elastic_integer/numeric_limits.h"
#include "_impl/elastic_integer/operators.h"
#include "_impl/elastic_integer/rep.h"
#include "_impl/elastic_integer/scale.h"
#include "_impl/elastic_integer/set_digits.h"
#include "_impl/elastic_integer/set_rep.h"
#include "_impl/elastic_integer/set_tag.h"
#include "_impl/elastic_integer/tag.h"
#include "_impl/elastic_tag.h"

#endif  // CNL_ELASTIC_INTEGER_H
