
//          Copyright John McFarlane 2015 - 2016.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file ../LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

/// \file
/// \brief all definitions related to the `cnl::scaled_integer` type

#if !defined(CNL_SCALED_INTEGER_H)
#define CNL_SCALED_INTEGER_H

#include "_impl/scaled_integer/convert_operator.h"
#include "_impl/scaled_integer/declaration.h"
#include "_impl/scaled_integer/extras.h"
#include "_impl/scaled_integer/fraction.h"
#include "_impl/scaled_integer/from_rep.h"
#include "_impl/scaled_integer/is_number.h"
#include "_impl/scaled_integer/is_scaled_integer.h"
#include "_impl/scaled_integer/math.h"
#include "_impl/scaled_integer/named.h"
#include "_impl/scaled_integer/num_traits.h"
#include "_impl/scaled_integer/numbers.h"
#include "_impl/scaled_integer/operators.h"
#include "_impl/scaled_integer/rep.h"
#include "_impl/scaled_integer/set_rep.h"
#include "_impl/scaled_integer/set_tag.h"
#include "_impl/scaled_integer/tag.h"
#include "_impl/scaled_integer/to_chars.h"
#include "_impl/scaled_integer/to_string.h"
#include "_impl/scaled_integer/type.h"

#endif  // CNL_SCALED_INTEGER_H
